#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

	int n;
	cin>>n;
    int a[n];
    for(int i=0;i<n;i++) cin >>a[i];
    vector<pair<int,int>> per;
    for(int i=0;i<n;i++)
    {
        for(int j=0;j<n-1;j++)
        {
            if(a[j]>a[j+1])
            {
                per.push_back({j+1,j+2});
                swap(a[j],a[j+1]);
            }
        }
    }
    cout<<per.size()<<'\n';
    for(int i=0;i<per.size();i++)cout<<per[i].first<<' '<<per[i].second<<'\n';
}
